CREADE PROCEDURE spCategoriesCrossfoot
AS
SET NOCOUNT ON
--Create the temporary tblCategoryCT table from the PIVOT query
SELECT Category, [Jan '06], [Feb '06], [Mar '06], [Apr '06], 
[May '06], [Jun '06], [Jul '06], [Aug '06],
[Sep '06], [Oct '06], [Nov '06], [Dec '06]
INTO #tblCategoryCT FROM qryCategoriesCT;

--Add a Row Totals Field
ALTER TABLE #tblCategoryCT ADD Totals money;

--Update the Total Field
UPDATE #tblCategoryCT SET Totals = 
IsNull([Jan '06],0) + IsNull([Feb '06],0) + IsNull([Mar '06],0) + IsNull([Apr '06],0) + 
IsNull([May '06],0) + IsNull([Jun '06],0) + IsNull([Jul '06],0) + IsNull([Aug '06],0) + 
IsNull([Sep '06],0) + IsNull([Oct '06],0) + IsNull([Nov '06],0) + IsNull([Dec '06],0);

--Following throws an error, unfortunately
--INSERT tblCategoryCT (Category, [Jan '06], [Feb '06], [Mar '06], [Apr '06]) 
--VALUES(N'Totals', SUM(IsNull([Jan '06],0)), SUM(IsNull([Feb '06],0)), SUM(IsNull([Mar '06],0)), SUM(IsNull([Apr '06],0))) 

--Get the column totals
DECLARE @Jan money
SET @Jan = (SELECT SUM(IsNull([Jan '06],0)) FROM #tblCategoryCT)
DECLARE @Feb money
SET @Feb = (SELECT SUM(IsNull([Feb '06],0)) FROM #tblCategoryCT)
DECLARE @Mar money
SET @Mar = (SELECT SUM(IsNull([Mar '06],0)) FROM #tblCategoryCT)
DECLARE @Apr money
SET @Apr = (SELECT SUM(IsNull([Apr '06],0)) FROM #tblCategoryCT)
DECLARE @May money
SET @May = (SELECT SUM(IsNull([May '06],0)) FROM #tblCategoryCT)
DECLARE @Jun money
SET @Jun = (SELECT SUM(IsNull([Jun '06],0)) FROM #tblCategoryCT)
DECLARE @Jul money
SET @Jul = (SELECT SUM(IsNull([Jul '06],0)) FROM #tblCategoryCT)
DECLARE @Aug money
SET @Aug = (SELECT SUM(IsNull([Aug '06],0)) FROM #tblCategoryCT)
DECLARE @Sep money
SET @Sep = (SELECT SUM(IsNull([Sep '06],0)) FROM #tblCategoryCT)
DECLARE @Oct money
SET @Oct = (SELECT SUM(IsNull([Oct '06],0)) FROM #tblCategoryCT)
DECLARE @Nov money
SET @Nov = (SELECT SUM(IsNull([Nov '06],0)) FROM #tblCategoryCT)
DECLARE @Dec money
SET @Dec = (SELECT SUM(IsNull([Dec '06],0)) FROM #tblCategoryCT)
DECLARE @Totals money
SET @Totals = (SELECT SUM(IsNull([Totals],0)) FROM #tblCategoryCT);

--Add and populate a Column Totals row
INSERT #tblCategoryCT VALUES('Totals', @Jan, @Feb, @Mar, @Apr, @May, 
@Jun, @Jul, @Aug, @Sep, @Oct, @Nov, @Dec, @Totals);

--Return the rows and drop the temporary table
SELECT * FROM #tblCategoryCT ORDER BY Category;
DROP TABLE #tblCategoryCT;
