SELECT TOP 2147483647 dbo.Categories.CategoryName, SUM(CONVERT(money, (dbo.[Order Details].UnitPrice * dbo.[Order Details].Quantity) 
   * (1 - dbo.[Order Details].Discount))) AS Amount, DATEPART(month, dbo.Orders.ShippedDate) AS MonthNum
FROM dbo.Categories INNER JOIN
   dbo.Products ON dbo.Categories.CategoryID = dbo.Products.CategoryID INNER JOIN
   dbo.Orders INNER JOIN
   dbo.[Order Details] ON dbo.Orders.OrderID = dbo.[Order Details].OrderID ON dbo.Products.ProductID = dbo.[Order Details].ProductID
WHERE (dbo.Orders.ShippedDate BETWEEN CONVERT(DATETIME, '2006-01-01 00:00:00', 102) AND CONVERT(DATETIME, '2006-12-31 00:00:00', 102))
GROUP BY dbo.Categories.CategoryName, DATEPART(month, dbo.Orders.ShippedDate)
ORDER BY dbo.Categories.CategoryName, MonthNum