<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
  <head>
    <meta HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=windows-1252">
    <title>Customers</title>
    <style type="text/css">
      table.t0 {border: solid skyblue 2px; border-collapse: collapse}
      th.t1 {background-color:skyblue; border: solid skyblue 2px}
      td.t2 {background-color:white; border: solid skyblue 2px}
      tr.r1 {vertical-align: top}	
      span.c2 {font-size: 11pt; color: black; font-family: Calibri,Tahoma,Arial,sans-serif}
      caption.c1 {font-size: 14pt; font-weight: bold; color: darkorange; font-family: Calibri,Tahoma,Arial,sans-serif}
    </style>
  </head>
  <body>

<% 'Set up session and open ODBC machine-level connection
Session.timeout = 5
If IsObject(Session("NwindAccess_conn")) Then
  Set conn = Session("NwindAccess_conn")
Else
  Set conn = Server.CreateObject("ADODB.Connection")
  conn.Open "NwindAccess","Administrator",""
  Set Session("NwindAccess_conn") = conn
End If %>

<% 'Create a Recordset
If IsObject(Session("Customers_rs")) Then
  Set rs = Session("Customers_rs")
Else
  sql = "SELECT * FROM [Customers]"
  Set rs = Server.CreateObject("ADODB.Recordset")
  rs.Open sql, conn, 3, 3
  If rs.Eof Then
    rs.AddNew
  End If
  Set Session("Customers_rs") = rs
End If %>

<!-- Start HTML -->
    <table class="t0">
      <caption class="c1">Customers</caption>
      <thead>
        <tr>
        <!-- Add tables headers (field names) -->
        <% For col = 0 To rs.Fields.Count -1 %>
          <th class="t1">
            <span class="c2">
              <!-- Add field names -->
              <%=Server.HTMLEncode(rs.Fields(col).Name)%>
            </span>
          </th>
        <% Next %>
        </tr>
      </thead>
      <tbody>
        <% On Error Resume Next
          'Add rows and cell values
          rs.MoveFirst
          Do While Not rs.Eof %>
          <tr class="r1">
          <% For col = 0 to rs.Fields.Count -1 %>
            <td class="t2">
              <span class="c2">
                <%=Server.HTMLEncode(rs.Fields(col).Value)%>
              </span>
            </td>
          <% Next %>
          </tr>
        <% rs.MoveNext
           Loop %>
      </tbody>
    </table>
  </body>
</html> 